Lucene++ - a full-featured, c++ search engine
API Documentation

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Static Protected Member Functions | Protected Attributes
Lucene::StandardFilter Class Reference

Normalizes tokens extracted with `StandardTokenizer`. More...

`#include <StandardFilter.h>`

Inheritance diagram for Lucene::StandardFilter:

## Public Member Functions

| StandardFilter (const TokenStreamPtr &input)
| Construct filtering input.
virtual | ~StandardFilter ()
virtual String | getClassName ()
boost::shared_ptr< StandardFilter > | shared_from_this ()
virtual bool | incrementToken ()
| Returns the next token in the stream, or null at EOS.
Public Member Functions inherited from Lucene::TokenFilter
virtual | ~TokenFilter ()
boost::shared_ptr< TokenFilter > | shared_from_this ()
virtual void | end ()
| Performs end-of-stream operations, if any, and calls then end() on the input TokenStream. NOTE: Be sure to call TokenFilter::end() first when overriding this method.
virtual void | close ()
| Close the input TokenStream.
virtual void | reset ()
| Reset the filter as well as the input TokenStream.
Public Member Functions inherited from Lucene::TokenStream
virtual | ~TokenStream ()
boost::shared_ptr< TokenStream > | shared_from_this ()
Public Member Functions inherited from Lucene::AttributeSource
| AttributeSource ()
| An AttributeSource using the default attribute factory `DefaultAttributeFactory`.
| AttributeSource (const AttributeSourcePtr &input)
| An AttributeSource that uses the same attributes as the supplied one.
| AttributeSource (const AttributeFactoryPtr &factory)
| An AttributeSource using the supplied `AttributeFactory` for creating new `Attribute` instances.
virtual | ~AttributeSource ()
boost::shared_ptr< AttributeSource > | shared_from_this ()
AttributeFactoryPtr | getAttributeFactory ()
| returns the used AttributeFactory.
template<class ATTR >
boost::shared_ptr< ATTR > | addAttribute ()
| This method first checks if an instance of that class is already in this AttributeSource and returns it. Otherwise a new instance is created, added to this AttributeSource and returned.
void | addAttribute (const String &className, const AttributePtr &attrImpl)
| Adds a custom Attribute instance.
bool | hasAttributes ()
| Returns true if this AttributeSource has any attributes.
template<class ATTR >
bool | hasAttribute ()
| Returns true, if this AttributeSource contains the passed-in Attribute.
template<class ATTR >
boost::shared_ptr< ATTR > | getAttribute ()
| Returns the instance of the passed in Attribute contained in this AttributeSource.
void | clearAttributes ()
| Resets all Attributes in this AttributeSource by calling `AttributeImpl#clear()` on each Attribute implementation.
AttributeSourceStatePtr | captureState ()
| Captures the state of all Attributes. The return value can be passed to `restoreState` to restore the state of this or another AttributeSource.
void | restoreState (const AttributeSourceStatePtr &state)

Restores this state by copying the values of all attribute implementations that this state contains into the attributes implementations of the targetStream. The targetStream must contain a corresponding instance for each argument contained in this state (eg. it is not possible to restore the state of an AttributeSource containing a TermAttribute into a AttributeSource using a Token instance as implementation).

virtual int32_t | hashCode ()
| Return hash code for this object.
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal.
virtual String | toString ()
| Returns a string representation of the object.
AttributeSourcePtr | cloneAttributes ()
| Performs a clone of all `AttributeImpl` instances returned in a new AttributeSource instance. This method can be used to eg. create another TokenStream with exactly the same attributes (using `AttributeSource(AttributeSource)`)
Collection< AttributePtr > | getAttributes ()
| Return a vector of attributes based on currentState.
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed.
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object.
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects.
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock.
virtual LuceneSignalPtr | getSignal ()
| Return this object signal.
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout.
virtual void | unlock ()
| Unlock this object.
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread.
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout.
virtual void | notifyAll ()
| Notify all threads waiting for signal.

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::TokenFilter
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::TokenStream
static String | _getClassName ()
Static Public Member Functions inherited from Lucene::AttributeSource
static String | _getClassName ()

## Static Protected Member Functions

static const String & | APOSTROPHE_TYPE ()
static const String & | ACRONYM_TYPE ()

## Protected Attributes

TypeAttributePtr | typeAtt
TermAttributePtr | termAtt
Protected Attributes inherited from Lucene::TokenFilter
TokenStreamPtr | input
| The source of tokens for this filter.
Protected Attributes inherited from Lucene::AttributeSource
AttributeFactoryPtr | factory
MapStringAttribute | attributes
AttributeSourceStatePtr | currentState
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::TokenFilter
| TokenFilter (const TokenStreamPtr &input)
| Construct a token stream filtering the given input.
Protected Member Functions inherited from Lucene::TokenStream
| TokenStream ()
| A TokenStream using the default attribute factory.
| TokenStream (const AttributeSourcePtr &input)
| A TokenStream that uses the same attributes as the supplied one.
| TokenStream (const AttributeFactoryPtr &factory)
| A TokenStream using the supplied AttributeFactory for creating new `Attribute` instances.
Protected Member Functions inherited from Lucene::AttributeSource
AttributePtr | getAttribute (const String &className)
| The caller must pass in a className value. This method checks if an instance of that class is already in this AttributeSource and returns it.
bool | hasAttribute (const String &className)
| Returns true, if this AttributeSource contains the passed-in Attribute.
void | computeCurrentState ()
Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

Normalizes tokens extracted with `StandardTokenizer`.

## Constructor & Destructor Documentation

## ◆ StandardFilter()

Lucene::StandardFilter::StandardFilter | ( | const TokenStreamPtr & | input | ) |

Construct filtering input.

## ◆ ~StandardFilter()

virtual Lucene::StandardFilter::~StandardFilter | ( |  | ) |

virtual

## Member Function Documentation

## ◆ _getClassName()

static String Lucene::StandardFilter::_getClassName | ( |  | ) |

inline static

## ◆ ACRONYM_TYPE()

static const String & Lucene::StandardFilter::ACRONYM_TYPE | ( |  | ) |

static protected

## ◆ APOSTROPHE_TYPE()

static const String & Lucene::StandardFilter::APOSTROPHE_TYPE | ( |  | ) |

static protected

## ◆ getClassName()

virtual String Lucene::StandardFilter::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::TokenFilter.

## ◆ incrementToken()

virtual bool Lucene::StandardFilter::incrementToken | ( |  | ) |

virtual

Returns the next token in the stream, or null at EOS.

Removes `'s` from the end of words. Removes dots from acronyms.

Implements Lucene::TokenStream.

## ◆ shared_from_this()

boost::shared_ptr< StandardFilter > Lucene::StandardFilter::shared_from_this | ( |  | ) |

inline

## Field Documentation

## ◆ termAtt

TermAttributePtr Lucene::StandardFilter::termAtt

protected

## ◆ typeAtt

TypeAttributePtr Lucene::StandardFilter::typeAtt

protected

The documentation for this class was generated from the following file:

- StandardFilter.h

clucene.sourceforge.net